Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.swing.text
Class BoxView

    java.lang.Object
      |
      +--javax.swing.text.View
            |
            +--javax.swing.text.CompositeView
                  |
                  +--javax.swing.text.BoxView

All Implemented Interfaces:
  SwingConstants

Direct Known Subclasses:
  BlockView, FlowView, TableView, TableView.TableCell, TableView.TableRow, WrappedPlainView, ZoneView

public class BoxView
extends CompositeView

A view that arranges its children into a box shape by tiling it's children along an axis. The box is somewhat like that found in TeX where there is alignment of the children, flexibility of the children is considered, etc. This is considered an useful building block that might be useful to represent things like a collection of lines, paragraphs, lists, columns, pages, etc.

Fields inherited from class javax.swing.text.View
`BadBreakWeight, ExcellentBreakWeight, ForcedBreakWeight, GoodBreakWeight, X_AXIS, Y_AXIS`

Fields inherited from interface javax.swing.SwingConstants
`BOTTOM, CENTER, EAST, HORIZONTAL, LEADING, LEFT, NORTH, NORTH_EAST, NORTH_WEST, RIGHT, SOUTH, SOUTH_EAST, SOUTH_WEST, TOP, TRAILING, VERTICAL, WEST`

Constructor Summary
`BoxView(Element elem, int axis)` Constructs a BoxView.

Method Summary
`protected void` | `baselineLayout(int targetSpan, int axis, int[] offsets, int[] spans)`
`protected SizeRequirements` | `baselineRequirements(int axis, SizeRequirements r)`
`protected SizeRequirements` | `calculateMajorAxisRequirements(int axis, SizeRequirements r)`
`protected SizeRequirements` | `calculateMinorAxisRequirements(int axis, SizeRequirements r)`
`protected void` | `childAllocation(int index, Rectangle alloc)` Allocates a region for a child view.
`protected boolean` | `flipEastAndWestAtEnds(int position, Position.Bias bias)` Subclasses may wish to subclass this and conditionally return true based on the position.
`protected void` | `forwardUpdate(DocumentEvent.ElementChange ec, DocumentEvent e, Shape a, ViewFactory f)` Forward the given DocumentEvent to the child views that need to be notified of the change to the model.
`float` | `getAlignment(int axis)` Determines the desired alignment for this view along an axis.
`int` | `getAxis()` Fetch the axis property.
`Shape` | `getChildAllocation(int index, Shape a)` Fetches the allocation for the given child view.
`int` | `getHeight()` The current height of the box.
`float` | `getMaximumSpan(int axis)` Determines the maximum span for this view along an axis.
`float` | `getMinimumSpan(int axis)` Determines the minimum span for this view along an axis.
`protected int` | `getOffset(int axis, int childIndex)` Fetch the offset of a particular childs current layout
`float` | `getPreferredSpan(int axis)` Determines the preferred span for this view along an axis.
`int` | `getResizeWeight(int axis)` Gets the resize weight.
`protected int` | `getSpan(int axis, int childIndex)` Fetch the span of a particular childs current layout
`protected View` | `getViewAtPoint(int x, int y, Rectangle alloc)` Fetches the child view at the given point.
`int` | `getWidth()` The current width of the box.
`protected boolean` | `isAfter(int x, int y, Rectangle innerAlloc)` Determines if a point falls after an allocated region.
`protected boolean` | `isAllocationValid()` Are the allocations for the children still valid?
`protected boolean` | `isBefore(int x, int y, Rectangle innerAlloc)` Determines if a point falls before an allocated region.
`protected void` | `layout(int width, int height)` Performs layout of the children.
`void` | `layoutChanged(int axis)` Invalidate the layout along an axis.
`protected void` | `layoutMajorAxis(int targetSpan, int axis, int[] offsets, int[] spans)` Perform layout for the major axis of the box (i.e.
`protected void` | `layoutMinorAxis(int targetSpan, int axis, int[] offsets, int[] spans)` Perform layout for the minor axis of the box (i.e.
`Shape` | `modelToView(int pos, Shape a, Position.Bias b)` Provides a mapping from the document model coordinate space to the coordinate space of the view mapped to it.
`void` | `paint(Graphics g, Shape allocation)` Renders using the given rendering surface and area on that surface.
`protected void` | `paintChild(Graphics g, Rectangle alloc, int index)` Paints a child.
`void` | `preferenceChanged(View child, boolean width, boolean height)` This is called by a child to indicated its preferred span has changed.
`void` | `replace(int index, int length, View[] elems)` Invalidates the layout and resizes the cache of requests/allocations.
`void` | `setAxis(int axis)` Set the axis property.
`void` | `setSize(float width, float height)` Sets the size of the view.
`int` | `viewToModel(float x, float y, Shape a, Position.Bias[] bias)` Provides a mapping from the view coordinate space to the logical coordinate space of the model.

Methods inherited from class javax.swing.text.CompositeView
`getBottomInset, getInsideAllocation, getLeftInset, getNextEastWestVisualPositionFrom, getNextNorthSouthVisualPositionFrom, getNextVisualPositionFrom, getRightInset, getTopInset, getView, getViewAtPosition, getViewCount, getViewIndex, getViewIndexAtPosition, loadChildren, modelToView, setInsets, setParagraphInsets, setParent`

Methods inherited from class javax.swing.text.View
`append, breakView, changedUpdate, createFragment, forwardUpdateToView, getAttributes, getBreakWeight, getContainer, getDocument, getElement, getEndOffset, getGraphics, getParent, getStartOffset, getViewFactory, insert, insertUpdate, isVisible, modelToView, remove, removeAll, removeUpdate, updateChildren, updateLayout, viewToModel`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### BoxView

    public BoxView(Element elem,
                   int axis)

  Constructs a BoxView.
  Parameters:
    `elem` - the element this view is responsible for
    `axis` - either View.X_AXIS or View.Y_AXIS

Method Detail

### getAxis

    public int getAxis()

  Fetch the axis property.
  Returns:
    the major axis of the box, either View.X_AXIS or View.Y_AXIS.

### setAxis

    public void setAxis(int axis)

  Set the axis property.
  Parameters:
    `axis` - either View.X_AXIS or View.Y_AXIS

### layoutChanged

    public void layoutChanged(int axis)

  Invalidate the layout along an axis. This happens automatically if the preferences have changed for any of the child views. In some cases the layout may need to be recalculated when the preferences have not changed. The layout can be marked as invalid by calling this method. The layout will be updated the next time the setSize method is called on this view (typically in paint).
  Parameters:
    `axis` - either View.X_AXIS or View.Y_AXIS

### paintChild

    protected void paintChild(Graphics g,
                              Rectangle alloc,
                              int index)

  Paints a child. By default that is all it does, but a subclass can use this to paint things relative to the child.
  Parameters:
    `g` - the graphics context
    `alloc` - the allocated region to paint into
    `index` - the child index, >= 0 && < getViewCount()

### replace

    public void replace(int index,
                        int length,
                        View[] elems)

  Invalidates the layout and resizes the cache of requests/allocations. The child allocations can still be accessed for the old layout, but the new children will have an offset and span of 0.
  Overrides:
    `replace` in class `CompositeView`
  Parameters:
    `index` - the starting index into the child views to insert the new views. This should be a value >= 0 and <= getViewCount.
    `length` - the number of existing child views to remove. This should be a value >= 0 and <= (getViewCount() - offset).
    `views` - the child views to add. This value can be null to indicate no children are being added (useful to remove).

### forwardUpdate

    protected void forwardUpdate(DocumentEvent.ElementChange ec,
                                 DocumentEvent e,
                                 Shape a,
                                 ViewFactory f)

  Forward the given DocumentEvent to the child views that need to be notified of the change to the model. If a child changed it's requirements and the allocation was valid prior to forwarding the portion of the box from the starting child to the end of the box will be repainted.
  Overrides:
    `forwardUpdate` in class `View`
  Parameters:
    `ec` - changes to the element this view is responsible for (may be null if there were no changes).
    `e` - the change information from the associated document
    `a` - the current allocation of the view
    `f` - the factory to use to rebuild if the view has children
  See Also:
    `View.insertUpdate(javax.swing.event.DocumentEvent, java.awt.Shape, javax.swing.text.ViewFactory)`, `View.removeUpdate(javax.swing.event.DocumentEvent, java.awt.Shape, javax.swing.text.ViewFactory)`, `View.changedUpdate(javax.swing.event.DocumentEvent, java.awt.Shape, javax.swing.text.ViewFactory)`

### preferenceChanged

    public void preferenceChanged(View child,
                                  boolean width,
                                  boolean height)

  This is called by a child to indicated its preferred span has changed. This is implemented to throw away cached layout information so that new calculations will be done the next time the children need an allocation.
  Overrides:
    `preferenceChanged` in class `View`
  Parameters:
    `child` - the child view
    `width` - true if the width preference should change
    `height` - true if the height preference should change

### getResizeWeight

    public int getResizeWeight(int axis)

  Gets the resize weight. A value of 0 or less is not resizable.
  Overrides:
    `getResizeWeight` in class `View`
  Parameters:
    `axis` - may be either View.X_AXIS or View.Y_AXIS
  Returns:
    the weight
  Throws:
    `IllegalArgumentException` - for an invalid axis

### setSize

    public void setSize(float width,
                        float height)

  Sets the size of the view. If the size has changed, layout is redone. The size is the full size of the view including the inset areas.
  Overrides:
    `setSize` in class `View`
  Parameters:
    `width` - the width >= 0
    `height` - the height >= 0

### paint

    public void paint(Graphics g,
                      Shape allocation)

  Renders using the given rendering surface and area on that surface. Only the children that intersect the clip bounds of the given Graphics will be rendered.
  Overrides:
    `paint` in class `View`
  Parameters:
    `g` - the rendering surface to use
    `allocation` - the allocated region to render into
  See Also:
    `View.paint(java.awt.Graphics, java.awt.Shape)`

### getChildAllocation

    public Shape getChildAllocation(int index,
                                    Shape a)

  Fetches the allocation for the given child view. This enables finding out where various views are located. This is implemented to return null if the layout is invalid, otherwise the superclass behavior is executed.
  Overrides:
    `getChildAllocation` in class `CompositeView`
  Parameters:
    `index` - the index of the child, >= 0 && < getViewCount()
    `a` - the allocation to this view.
  Returns:
    the allocation to the child

### modelToView

    public Shape modelToView(int pos,
                             Shape a,
                             Position.Bias b)
                      throws BadLocationException

  Provides a mapping from the document model coordinate space to the coordinate space of the view mapped to it. This makes sure the allocation is valid before letting the superclass do its thing.
  Overrides:
    `modelToView` in class `CompositeView`
  Parameters:
    `pos` - the position to convert >= 0
    `a` - the allocated region to render into
  Returns:
    the bounding box of the given position
  Throws:
    `BadLocationException` - if the given position does not represent a valid location in the associated document
  See Also:
    `View.modelToView(int, java.awt.Shape, javax.swing.text.Position.Bias)`

### viewToModel

    public int viewToModel(float x,
                           float y,
                           Shape a,
                           Position.Bias[] bias)

  Provides a mapping from the view coordinate space to the logical coordinate space of the model.
  Overrides:
    `viewToModel` in class `CompositeView`
  Parameters:
    `x` - x coordinate of the view location to convert >= 0
    `y` - y coordinate of the view location to convert >= 0
    `a` - the allocated region to render into
  Returns:
    the location within the model that best represents the given point in the view >= 0
  See Also:
    `View.viewToModel(float, float, java.awt.Shape, javax.swing.text.Position.Bias[])`

### getAlignment

    public float getAlignment(int axis)

  Determines the desired alignment for this view along an axis. This is implemented to give the total alignment needed to position the children with the alignment points lined up along the axis orthoginal to the axis that is being tiled. The axis being tiled will request to be centered (i.e. 0.5f).
  Overrides:
    `getAlignment` in class `View`
  Parameters:
    `axis` - may be either View.X_AXIS or View.Y_AXIS
  Throws:
    `IllegalArgumentException` - for an invalid axis

### getPreferredSpan

    public float getPreferredSpan(int axis)

  Determines the preferred span for this view along an axis.
  Overrides:
    `getPreferredSpan` in class `View`
  Parameters:
    `axis` - may be either View.X_AXIS or View.Y_AXIS
  Throws:
    `IllegalArgumentException` - for an invalid axis type

### getMinimumSpan

    public float getMinimumSpan(int axis)

  Determines the minimum span for this view along an axis.
  Overrides:
    `getMinimumSpan` in class `View`
  Parameters:
    `axis` - may be either View.X_AXIS or View.Y_AXIS
  Throws:
    `IllegalArgumentException` - for an invalid axis type

### getMaximumSpan

    public float getMaximumSpan(int axis)

  Determines the maximum span for this view along an axis.
  Overrides:
    `getMaximumSpan` in class `View`
  Parameters:
    `axis` - may be either View.X_AXIS or View.Y_AXIS
  Throws:
    `IllegalArgumentException` - for an invalid axis type

### isAllocationValid

    protected boolean isAllocationValid()

  Are the allocations for the children still valid?
  Returns:
    true if allocations still valid

### isBefore

    protected boolean isBefore(int x,
                               int y,
                               Rectangle innerAlloc)

  Determines if a point falls before an allocated region.
  Overrides:
    `isBefore` in class `CompositeView`
  Parameters:
    `x` - the X coordinate >= 0
    `y` - the Y coordinate >= 0
    `innerAlloc` - the allocated region. This is the area inside of the insets.
  Returns:
    true if the point lies before the region else false

### isAfter

    protected boolean isAfter(int x,
                              int y,
                              Rectangle innerAlloc)

  Determines if a point falls after an allocated region.
  Overrides:
    `isAfter` in class `CompositeView`
  Parameters:
    `x` - the X coordinate >= 0
    `y` - the Y coordinate >= 0
    `innerAlloc` - the allocated region. This is the area inside of the insets.
  Returns:
    true if the point lies after the region else false

### getViewAtPoint

    protected View getViewAtPoint(int x,
                                  int y,
                                  Rectangle alloc)

  Fetches the child view at the given point.
  Overrides:
    `getViewAtPoint` in class `CompositeView`
  Parameters:
    `x` - the X coordinate >= 0
    `y` - the Y coordinate >= 0
    `alloc` - the parents inner allocation on entry, which should be changed to the childs allocation on exit.
  Returns:
    the view

### childAllocation

    protected void childAllocation(int index,
                                   Rectangle alloc)

  Allocates a region for a child view.
  Overrides:
    `childAllocation` in class `CompositeView`
  Parameters:
    `index` - the index of the child view to allocate, >= 0 && < getViewCount()
    `alloc` - the allocated region

### layout

    protected void layout(int width,
                          int height)

  Performs layout of the children. The size is the area inside of the insets. This method calls the methods layoutMajorAxis and layoutMinorAxis as needed. To change how layout is done those methods should be reimplemented.
  Parameters:
    `width` - the width >= 0
    `height` - the height >= 0

### getWidth

    public int getWidth()

  The current width of the box. This is the width that it was last allocated.

### getHeight

    public int getHeight()

  The current height of the box. This is the height that it was last allocated.

### layoutMajorAxis

    protected void layoutMajorAxis(int targetSpan,
                                   int axis,
                                   int[] offsets,
                                   int[] spans)

  Perform layout for the major axis of the box (i.e. the axis that it represents). The results of the layout should be placed in the given arrays which represent the allocations to the children along the major axis.
  Parameters:
    `targetSpan` - the total span given to the view, which whould be used to layout the children.
    `axis` - the axis being layed out.
    `offsets` - the offsets from the origin of the view for each of the child views. This is a return value and is filled in by the implementation of this method.
    `spans` - the span of each child view. This is a return value and is filled in by the implementation of this method.

### layoutMinorAxis

    protected void layoutMinorAxis(int targetSpan,
                                   int axis,
                                   int[] offsets,
                                   int[] spans)

  Perform layout for the minor axis of the box (i.e. the axis orthoginal to the axis that it represents). The results of the layout should be placed in the given arrays which represent the allocations to the children along the minor axis.
  Parameters:
    `targetSpan` - the total span given to the view, which whould be used to layout the children.
    `axis` - the axis being layed out.
    `offsets` - the offsets from the origin of the view for each of the child views. This is a return value and is filled in by the implementation of this method.
    `spans` - the span of each child view. This is a return value and is filled in by the implementation of this method.

### calculateMajorAxisRequirements

    protected SizeRequirements calculateMajorAxisRequirements(int axis,
                                                              SizeRequirements r)

### calculateMinorAxisRequirements

    protected SizeRequirements calculateMinorAxisRequirements(int axis,
                                                              SizeRequirements r)

### baselineLayout

    protected void baselineLayout(int targetSpan,
                                  int axis,
                                  int[] offsets,
                                  int[] spans)

### baselineRequirements

    protected SizeRequirements baselineRequirements(int axis,
                                                    SizeRequirements r)

### getOffset

    protected int getOffset(int axis,
                            int childIndex)

  Fetch the offset of a particular childs current layout

### getSpan

    protected int getSpan(int axis,
                          int childIndex)

  Fetch the span of a particular childs current layout

### flipEastAndWestAtEnds

    protected boolean flipEastAndWestAtEnds(int position,
                                            Position.Bias bias)

  Description copied from class: `CompositeView`
  Subclasses may wish to subclass this and conditionally return true based on the position. A return value of true indicates that when a View returns -1 from getNextVisualPositionFrom the next view for east should be the current index offset by -1, and for west it means offset by 1. The normal direction (for left to right text) is to offset east by 1 and west by -1.
  Overrides:
    `flipEastAndWestAtEnds` in class `CompositeView`
  Following copied from class: `javax.swing.text.CompositeView`
  Returns:
    false

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2001 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.